var planets = new Array
var objects = new Array
var force

function addPlanet(entityId) {
  planets.push(entityManager.getEntityById(entityId))
}

function addObject(entityId) {
  objects.push(entityManager.getEntityById(entityId))
}

function removeObject(entity) {
  for(var i=0; i<objects.length; i++) {
    if(objects[i].entityId === entity.entityId) {
      objects.splice(i,1)
      return
    }
  }
}

function startObjects() {
  for(var i = 0; i < objects.length; i++) {
    objects[i].applyGravityImpuls(Qt.point(50,0))
  }
}

function applyGravity() {
  for(var i = 0; i < objects.length; i++) {
    var object = objects[i]
    var objectPosition = object.getPosition()
    for(var j = 0; j < planets.length; j++) {
      var planet = planets[j]
      var planetPosition = planet.getPosition()
      var distance = Math.sqrt(Math.pow(Math.abs(objectPosition.x-planetPosition.x),2)+Math.pow(Math.abs(objectPosition.y-planetPosition.y),2))
      if(distance > planet.gravityRadius) continue
      var atanY = planetPosition.y - objectPosition.y;
      var atanX = planetPosition.x - objectPosition.x;
      var angle = Math.atan2(atanY, atanX);
      var impulseX = force*Math.cos(angle)*(1+distance/80)
      var impulseY = force*Math.sin(angle)*(1+distance/80)
      object.applyGravityImpuls(Qt.point(impulseX,impulseY))
    }
  }
}

function getThatShitOfMe(planet) {
  for(var i = 0; i < objects.length; i++) {
    var object = objects[i]
    var objectPosition = object.getPosition()
    var planetPosition = planet.getPosition()
    var distance = Math.sqrt(Math.pow(Math.abs(objectPosition.x-planetPosition.x),2)+Math.pow(Math.abs(objectPosition.y-planetPosition.y),2))
    if(distance > planet.gravityRadius) continue
    var atanY = planetPosition.y - objectPosition.y;
    var atanX = planetPosition.x - objectPosition.x;
    var angle = Math.atan2(atanY, atanX);
    var impulseX = -force*Math.cos(angle)*18
    var impulseY = -force*Math.sin(angle)*18
    object.applyGravityImpuls(Qt.point(impulseX,impulseY))
  }
}
